'use strict';

/**
 * @ngdoc overview
 * @name visualMinersApp
 * @description
 * # visualMinersApp
 *
 * Main module of the application.
 */
angular
  .module('visualMinersApp', [
    'ngAnimate',
    'ngCookies',
    'ngResource',
    'ngRoute',
    'ngSanitize',
    'ngTouch',
    'duScroll'
  ])
  .config(function ($routeProvider,$locationProvider) {
    $locationProvider.hashPrefix('');
    $routeProvider
      // .when('/', {
      //   templateUrl: 'static/views/main.html',
      //   controller: 'MainCtrl',
      //   controllerAs: 'main'
      // })

      .when('/map', {
        templateUrl: 'static/views/map.html',
        controller: 'MapCtrl',
        controllerAs: 'map'
      })

      .when('/offer', {
        templateUrl: 'static/views/offer.html',
        controller: 'OfferCtrl',
        controllerAs: 'map'
      })

      .when('/demography', {
        templateUrl: 'static/views/demography.html',
        controller: 'DemographyCtrl',
        controllerAs: 'map'
      })

      .when('/transportation', {
        templateUrl: 'static/views/transportation.html',
        controller: 'TransportationCtrl',
        controllerAs: 'transport'
      })

      .when('/richness', {
        templateUrl: 'static/views/richness.html',
        controller: 'RichnessCtrl',
        controllerAs: 'map'
      })

      .when('/valencia', {
        templateUrl: 'static/views/valencia.html',
        controller: 'ValenciaCtrl',
        controllerAs: 'valencia'
      })


      .when('/about', {
        templateUrl: 'static/views/about.html',
        controller: 'AboutCtrl',
        controllerAs: 'about'
      })


      .otherwise({
        redirectTo: '/map'
      });
  });
