'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('DemographyCtrl', function ($scope, $location) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];


    var populationCategoryColors = ['#fff7fb','#ece7f2','#d0d1e6','#a6bddb','#74a9cf','#3690c0','#0570b0','#045a8d','#023858'];
    var populationCategoryNames = ["< 1000 people", "1000-4999 people", "5000-7499 people", "7500-9999 people", "10000-14999 people", "20000-39999 people", "40000-59999 people", "60000-99999 people", "> 100000 people"];



    $scope.options = {
      origin:1,
      granularity:0,
      info:2
    };

    $("#lateral_container_demography").css("width", screen.width * 0.25 + "px");
    $("#lateral_container_demography").css("margin-left", screen.width * 0.03 + "px");
    $("#lateral_container_demography").css("height", screen.height * 0.60 + "px");

    $scope.currentTimestamp;
    $scope.currentTimestampIdx=0;
    $scope.availableTimestamps = [];

    var cpPolygons;
    var cpPolygonsPopulationData;
    var cpPolygonsPopulationDataStatistics = {};

    var choosenPolygon;

    var colorToAssign;

    var tmp;
    $scope.currentOptionSelected = 0;

    var selectedRowFromPopulationData;


    var getPopulationColorForpPolygon = function(CP, filterOtion){
      var categoryString;

      if(filterOtion == 0){
        categoryString="Total";
      }else if(filterOtion){
        categoryString="Hombres";
      }else{
        categoryString="Mujeres";
      }

      selectedRowFromPopulationData = cpPolygonsPopulationData.filter(function(d){
        return d.CodigoPostal == CP;
      });
      if(selectedRowFromPopulationData.length > 0){
        selectedRowFromPopulationData = selectedRowFromPopulationData[0];

        if(selectedRowFromPopulationData[categoryString] < 1000){
          return populationCategoryColors[0];
        }else if(selectedRowFromPopulationData[categoryString] < 5000){
          return populationCategoryColors[1];
        }else if(selectedRowFromPopulationData[categoryString] < 7500){
          return populationCategoryColors[2];
        }else if(selectedRowFromPopulationData[categoryString] < 10000){
          return populationCategoryColors[3];
        }else if(selectedRowFromPopulationData[categoryString] < 20000){
          return populationCategoryColors[4];
        }else if(selectedRowFromPopulationData[categoryString] < 40000){
          return populationCategoryColors[5];
        }else if(selectedRowFromPopulationData[categoryString] < 60000){
          return populationCategoryColors[6];
        }else if(selectedRowFromPopulationData[categoryString] < 100000){
          return populationCategoryColors[7];
        } else{
          return populationCategoryColors[8];
        }
      }else{
        return "black";
      }

    };

    var changePolygonColors = function(optionIdx){

      // 0-> Total population
      // 1-> Men
      // 2-> Women
      console.log("Changing category colors for optionIdx: ", optionIdx);

      cpPolygons.each(function(d, i) {
        // console.log("Polygon: ", d, i);
        choosenPolygon = d3.select("#CP_"+d.properties.COD_POSTAL);

        colorToAssign = getPopulationColorForpPolygon(d.properties.COD_POSTAL, optionIdx);
        choosenPolygon
          .style("opacity", 0.8)
          .style("fill", colorToAssign);

      });
    };

    $scope.populationOptionsChanged = function(){

      changePolygonColors($scope.currentOptionSelected);

    };

    $scope.infoOptionsChanged = function(){
      console.log("Information option changed to: " + $scope.options.info);

      if($scope.options.info == 0){  // Consumption
        $location.path( "/map" );
      }
      else if($scope.options.info == 1){  // Commercial offer
        $location.path( "/offer" );
      }
      // else if($scope.options.info == 2){  // Demography
      //   $location.path( "/demography" );
      // }
      else if($scope.options.info == 3){  // Transportation
        $location.path( "/transportation" );
      }
      else if($scope.options.info == 4){  // Richness
        $location.path( "/richness" );
      }

    };

    $scope.transactionsOptionsChanged = function() {
      console.log("Transactions option changed");
      dateChanged($scope.currentTimestampIdx);
    };




    var createMap = function() {


      var width = screen.width * 0.66;
      var height = screen.height * 0.78;


      $("#demographyMap").css("width", width + "px");
      $("#demographyMap").css("height", height + "px");
      $("#demographyMap").css("margin-left", screen.width * 0.07 + "px");


      //d3.select("#lineChart").node().getBBox().width;

      var legendHeight = screen.height * 0.35;

      // console.log("legendHeight: ", legendHeight);


      // var map = new L.Map("map", {center: [39.469214, -0.364603], zoom: 9});
      // var map = new L.Map("map", {center: [39.360966, -0.354603], zoom: 9});

      var map = new L.Map("demographyMap", {center: [39.288466, -0.434941], zoom: 9});

      //.addLayer(new L.TileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"));

      map.options.maxZoom = 14;
      map.options.minZoom = 8;

      var svg = d3.select(map.getPanes().overlayPane)
        .append("svg");

      svg.attr('width', width)
        .attr('height', height)
        .attr("class", "clickable");

      var g = svg.append("g")
        .attr("class", "leaflet-zoom-hide")
        .style("z-index", 9);
      var result;

      var tip = d3.tip()
        .attr('class', 'd3-tip')
        .offset([-10, 0])
        .html(function(d) {

          console.log("d: ", d);

           result = cpPolygonsPopulationData.filter(function(p){
            return p.CodigoPostal == d.properties.COD_POSTAL;
          });

           result = result[0]

          return "<h4> Postal code: "+d.properties.COD_POSTAL+"</h4><br>"+
            "<strong>Total:</strong> <span style='color:dodgerblue'>" + parseInt(result.Total) + "</span><br>" +
          "<strong>Men:</strong> <span style='color:dodgerblue'>" + parseInt(result.Hombres) + "</span><br>" +
          "<strong>Women:</strong> <span style='color:dodgerblue'>" + parseInt(result.Mujeres) + "</span><br>" ;

        });

      d3.json("data/postales/cp_valencia_province.geojson", function (error, geojson) {

        // console.log("Extracted data: ", geojson);
        var transform = d3.geo.transform({point: projectPoint}),
          path = d3.geo.path().projection(transform);

        var feature = g.selectAll("path")
          .data(geojson.features)
          .enter()
          .append("path")
          .attr("id", function (d) {
            return "CP_"+d.properties.COD_POSTAL;
          })
          .style("stroke", "grey")
          .style("stroke-width", "0.5")
          // .style("fill", function(d,i) { return color(i%10); } )
          // .style("opacity", 0.8);
          .style("opacity", 0);


        feature.call(tip);

        feature.on('mouseover', tip.show)
          .on('mouseout', tip.hide)
        cpPolygons = feature;

        map.on("viewreset", reset);
        reset();

        // Reposition the SVG to cover the features.
        function reset() {
          var bounds = path.bounds(geojson),
            topLeft = bounds[0],
            bottomRight = bounds[1];

          svg.attr("width", bottomRight[0] - topLeft[0])
            .attr("height", bottomRight[1] - topLeft[1])
            .style("left", topLeft[0] + "px")
            .style("top", (topLeft[1] -legendHeight * 1.9) + "px");

          g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");

          feature.attr("d", path);
        }


        // Use Leaflet to implement a D3 geometric transformation.
        function projectPoint(x, y) {
          var point = map.latLngToLayerPoint(new L.LatLng(y, x));
          this.stream.point(point.x, point.y);

        }




        var parser = d3.dsv(";","text/plain");
        parser("/data/ine/demographics.csv", function(csvError, csvData) {
          console.log("csv Data :: ", csvData);
          // console.log("Date IDX: ",$scope.currentTimestampIdx);
          // console.log("Data from that date: ", csvData[$scope.currentTimestampIdx]);


          cpPolygonsPopulationData = csvData;

          // var max = d3.max(cpPolygonsPopulationData, function(d) { return d[categoryString]});
          // var min = d3.max(cpPolygonsPopulationData, function(d) { return d[categoryString]});

          //   var totalMin = cpPolygonsPopulationData[0]["Total"];//d3.min(cpPolygonsPopulationData, function(d) { return d["Total"]});
          // var totalMax = cpPolygonsPopulationData[0]["Total"];//d3.max(cpPolygonsPopulationData, function(d) { return d["Total"]});
          //
          // var hombresMax = cpPolygonsPopulationData[0]["Hombres"];//d3.max(cpPolygonsPopulationData, function(d) { return d["Hombres"]});
          // var hombresMin = cpPolygonsPopulationData[0]["Hombres"];//d3.min(cpPolygonsPopulationData, function(d) { return d["Hombres"]});
          //
          // var mujeresMax = cpPolygonsPopulationData[0]["Mujeres"];//d3.max(cpPolygonsPopulationData, function(d) { console.log("D:", d);return d["Mujeres"]});
          // var mujeresMin = cpPolygonsPopulationData[0]["Mujeres"];//d3.min(cpPolygonsPopulationData, function(d) { return d["Mujeres"]});


          var totalMax = d3.max(cpPolygonsPopulationData, function(d) { return parseInt(d["Total"])});
          var totalMin = d3.min(cpPolygonsPopulationData, function(d) { return parseInt(d["Total"])});

          var hombresMax = d3.max(cpPolygonsPopulationData, function(d) { return parseInt(d["Hombres"])});
          var hombresMin = d3.min(cpPolygonsPopulationData, function(d) { return parseInt(d["Hombres"])});

          var mujeresMax = d3.max(cpPolygonsPopulationData, function(d) { return parseInt(d["Mujeres"])});
          var mujeresMin = d3.min(cpPolygonsPopulationData, function(d) { return parseInt(d["Mujeres"])});


          // cpPolygonsPopulationData.forEach(function(d){
          //   console.log("d: ", d);
          //   if( d["Total"] > totalMax){
          //     totalMax = d["Total"];
          //   }else if( d["Total"] < totalMin){
          //     totalMin = d["Total"];
          //   }
          //
          //   if( d["Hombres"] > hombresMax){
          //     hombresMax = d["Hombres"];
          //   }else if( d["Hombres"] < hombresMin){
          //     hombresMin = d["Hombres"];
          //   }
          //
          //   if( d["Mujeres"] > mujeresMax){
          //     mujeresMax = d["Mujeres"];
          //   } else if( d["Mujeres"] < mujeresMin){
          //     totalMin = d["Mujeres"];
          //   }
          // });

          cpPolygonsPopulationDataStatistics["Total"] = {max: totalMax, min: totalMin};
          cpPolygonsPopulationDataStatistics["Hombres"] = {max: hombresMax, min: hombresMin};
          cpPolygonsPopulationDataStatistics["Mujeres"] = {max: mujeresMax, min: mujeresMin};

          console.log("Statistics: ", cpPolygonsPopulationDataStatistics);

          changePolygonColors($scope.currentOptionSelected);
          var legendRectSize = 20;
          var legendSpacing = 5;



          var legendContainer = d3.select('#populationMapProperties')
            .attr("height", height*0.7)
            .attr("transform", "translate(" + width*0.8 + ",100)");


          var legendG = legendContainer
          // var legend = svg
            .append("g")
            .style("z-index", 9999);
          var legend = legendG
            .selectAll("g")
            .data(populationCategoryColors)
            .enter()
            .append('g')
            .attr('class', 'legend')
            .attr('transform', function(d, i) {
              var partialHeight = legendRectSize;
              var x = 0;
              var y = i * partialHeight;
              return 'translate(' + x + ',' + y + ')';
            });


          legend.append('rect')
            .attr('width', legendRectSize)
            .attr('height', legendRectSize)
            .style('fill', function(d, i){
              return populationCategoryColors[i];
            })
            .style('stroke', function(d, i){
              return populationCategoryColors[i];
            });

          // legendG.append("text").text("Legend (by population)").attr("fill", "white");
          legend.append('text')
            .attr('x', legendRectSize + legendSpacing)
            .attr('y', legendRectSize - legendSpacing)
            .attr("fill", "white")
            .text(function(d, i) { return populationCategoryNames[i]; });

          introJs().start();

        });
      });
    };
    $scope.showTutorial = function(){
      introJs().start();
    }

    createMap();
  });
