'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('MapCtrl', function ($scope, $location) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];

    // var categoryColors = ['#9e0142','#d53e4f','#f46d43','#fdae61','#fee08b','#e6f598','#abdda4','#66c2a5','#3288bd','#5e4fa2', '#888888']//["#ffffd9","#edf8b1","#c7e9b4","#7fcdbb","#41b6c4","#1d91c0","#225ea8","#253494","#081d58", "#ffffff"];

    var categoryColors = ['#8dd3c7','#ffffb3','#bebada','#fb8072','#80b1d3','#fdb462','#b3de69','#fccde5','#d9d9d9','#bc80bd','#ccebc5'];
    var categoryNames = ["ALIMENTACION","AUTO","BELLEZA","HIPERMERCADOS","HOGAR","MODA Y COMPLEMENTOS","OCIO Y TIEMPO LIBRE","OTROS","RESTAURACION","SALUD","TECNOLOGIA"];



    $scope.options = {
      origin:1,
      granularity:0,
      info:0
    };


    var color = d3.scale.ordinal()
      .domain(categoryNames)
      .range(categoryColors);

    $scope.categoryColors = categoryColors;
    $scope.categoryNames = categoryNames;

    $("#lateral_container_map").css("width", screen.width * 0.25 + "px");
    $("#lateral_container_map").css("margin-left", screen.width * 0.03 + "px");
    $("#lateral_container_map").css("height", screen.height * 0.60 + "px");
    // $("#lateral_container").css("background-color", "white");


    $scope.currentTimestamp;
    $scope.currentTimestampIdx=0;
    $scope.availableTimestamps = [];

    var cpPolygons;
    var cpPolygonsData;
    var choosenPolygon;

    var colorToAssign;
    var categoryToAssign;

    var tmp;
    var category;


    var weatherData;

    $scope.currentDateWeather = "Sun";


    var selectWeatherIcon = function(dateIdx){
      if(cpPolygonsData[dateIdx] && weatherData[dateIdx].prec == "False"){
        console.log("Sun");

        $scope.currentDateWeather = "Sun";
      }else{
        console.log("Rain");

        $scope.currentDateWeather = "Rain";
      }
    };

    var chooseCategoryForCP = function(cpId, dateIdx, tipus){

      // Use tipus 0 for showing data by VOLUME of transactions
      // Use tipus 1 for showing data by NUMBER of transactions

      if(cpPolygonsData[dateIdx] && cpPolygonsData[dateIdx].hasOwnProperty(cpId)) {
        if (tipus == 0) {
          tmp = cpPolygonsData[dateIdx][cpId].substring(0, 2);
        } else {
          tmp = cpPolygonsData[dateIdx][cpId].substring(2);
        }
        return chooseColorForCP(tmp);
      }else{
        return "black"
      }





    };

    var chooseColorForCP = function(numCategory){
      if(numCategory == ""){
        return "#060606";
      }else{

        if(numCategory < 2){
          numCategory = numCategory *10;
        }
        if(numCategory != 10) {
          numCategory = numCategory%10;
        }


        return categoryColors[numCategory];

        // return color(Math.floor((Math.random() * 10) + 1)%10);

      }
    };

    var changePolygonColors = function(dateIdx){
      console.log("Changing category colors for day: ", dateIdx);

      cpPolygons.each(function(d, i) {
        // console.log("Polygon: ", d, i);
        choosenPolygon = d3.select("#CP_"+d.properties.COD_POSTAL);

        colorToAssign = chooseCategoryForCP(d.properties.COD_POSTAL, dateIdx, $scope.options.origin);
        choosenPolygon
          .style("opacity", 0.8)
          .style("fill", colorToAssign);

      });
    };

    var dateChanged = function(dateIdx){

      changePolygonColors(dateIdx);

      if(weatherData !== undefined){

        selectWeatherIcon(dateIdx);
      }

    };

    $scope.infoOptionsChanged = function(){
      console.log("Information option changed to: " + $scope.options.info);

      // if($scope.options.info == 0){  // Consumption
      //   $location.path( "/map" );
      // }
      if($scope.options.info == 1){  // Commercial offer
        $location.path( "/offer" );
      }
      else if($scope.options.info == 2){  // Demographics
        $location.path( "/demography" );
      }
      else if($scope.options.info == 3){  // Transportation
        $location.path( "/transportation" );
      }
      else if($scope.options.info == 4){  // Richness
        $location.path( "/richness" );
      }

    };

    $scope.transactionsOptionsChanged = function() {
      console.log("Transactions option changed");
      dateChanged($scope.currentTimestampIdx);
      if($scope.options.origin == 0){
        createLineChartVolume();
      }else if($scope.options.origin == 1){
        createLineChartNumber();
      }
    };


    var createMap = function() {


      var width = screen.width * 0.66;
      var height = screen.height * 0.67;


      $("#map").css("width", width + "px");
      $("#map").css("height", height + "px");
      $("#map").css("margin-left", screen.width * 0.07 + "px");


      //d3.select("#lineChart").node().getBBox().width;

      var legendHeight = screen.height * 0.35;

      // console.log("legendHeight: ", legendHeight);


      // var map = new L.Map("map", {center: [39.469214, -0.364603], zoom: 9});
      // var map = new L.Map("map", {center: [39.360966, -0.354603], zoom: 9});

      var map = new L.Map("map", {center: [39.288466, -0.434941], zoom: 9});

      // map.addLayer(new L.TileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"));

      map.options.maxZoom = 14;
      map.options.minZoom = 8;


      var svg = d3.select(map.getPanes().overlayPane)
        .append("svg");

      svg.attr('width', width)
        .attr('height', height)
        .attr("class", "clickable");

      var g = svg.append("g")
        .attr("class", "leaflet-zoom-hide")
        .style("z-index", 9999);

      var tip = d3.tip()
        .attr('class', 'd3-tip')
        .offset([-10, 0])
        .html(function(d) {
          return "<h4> Postal code: "+d.properties.COD_POSTAL+"</h4><br>";

        });


      d3.json("data/postales/cp_valencia_province.geojson", function (error, geojson) {

        // console.log("Extracted data: ", geojson);
        var transform = d3.geo.transform({point: projectPoint}),
          path = d3.geo.path().projection(transform);

        var feature = g.selectAll("path")
          .data(geojson.features)
          .enter()
          .append("path")
          .attr("id", function (d) {
            return "CP_"+d.properties.COD_POSTAL;
          })
          .style("stroke", "grey")
          .style("stroke-width", "0.5")
          // .style("fill", function(d,i) { return color(i%10); } )
          // .style("opacity", 0.8);
          .style("opacity", 0);



        feature.call(tip);

        feature.on('mouseover', tip.show)
          .on('mouseout', tip.hide)
        cpPolygons = feature;

        map.on("viewreset", reset);
        reset();

        // Reposition the SVG to cover the features.
        function reset() {
          var bounds = path.bounds(geojson),
            topLeft = bounds[0],
            bottomRight = bounds[1];

          svg.attr("width", bottomRight[0] - topLeft[0])
            .attr("height", bottomRight[1] - topLeft[1])
            .style("left", topLeft[0] + "px")
            .style("top", (topLeft[1] -legendHeight*1.4) + "px");

          g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");

          feature.attr("d", path);
        }


        // Use Leaflet to implement a D3 geometric transformation.
        function projectPoint(x, y) {
          var point = map.latLngToLayerPoint(new L.LatLng(y, x));
          this.stream.point(point.x, point.y);
        }


        var parser = d3.dsv(";","text/plain");
        parser("/data/cajamar_data/determine_sector_day_byclient.csv", function(csvError, csvData) {
          // console.log("csv Data :: ", csvData);
          // console.log("Date IDX: ",$scope.currentTimestampIdx);
          // console.log("Data from that date: ", csvData[$scope.currentTimestampIdx]);

          introJs().start();

          cpPolygonsData = csvData;

          changePolygonColors($scope.currentTimestampIdx);

        });
      });
    };


    $scope.showTutorial = function(){
      introJs().start();
    }
    var createLineChartVolume = function(){
      d3.select(".expensesChart").remove();
      $(".expensesChart").remove();

      var svg = d3.select("#expenses-chart-map").append("svg"),
        margin = {top: 20, right: screen.width*0.04, bottom: 30, left: 50},
        width = screen.width*0.90,
        height = screen.height * 0.18 - margin.top - margin.bottom,
        g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      svg.attr("class", "expensesChart");

      var parseDate = d3.time.format("%Y-%m-%d").parse;

      var x = d3.time.scale()
        .range([0, width]);

      var y = d3.scale.linear()
        .range([height, 0]);


      var xAxis = d3.svg.axis()
        .scale(x)
        .orient("bottom");

      var yAxis = d3.svg.axis()
        .scale(y)
        .orient("left");

      var line = d3.svg.line()
        .interpolate("basis")
        .x(function(d) { return x(d.date); })
        .y(function(d) { return y(d.expense); });

      svg
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
        .attr("id","lineChartMap")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      //

      // d3.csv("/data/cajamar_data/imp_sec_ts.csv", function(error, data) {
      d3.csv("/data/cajamar_data/sector_counts.csv", function(error, data) {
        $scope.availableTimestamps = [];
        if (error) throw error;

        color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

        data.forEach(function(d) {
          // console.log("d: ", d);

          $scope.availableTimestamps.push(d.date);
          d.date = parseDate(d.date);
        });

        var categories = color.domain().map(function(name) {
          return {
            name: name,
            values: data.map(function(d) {
              return {date: d.date, expense: +d[name]};
            })
          };
        });

        x.domain(d3.extent(data, function(d) { return d.date; }));

        y.domain([
          d3.min(categories, function(c) { return d3.min(c.values, function(v) { return v.expense; }); }),
          d3.max(categories, function(c) { return d3.max(c.values, function(v) { return v.expense; }); })
        ]);

        g.append("g")
          .attr("class", "x axis")
          .attr("transform", "translate(0," + height + ")")
          .call(xAxis);

        g.append("g")
          .attr("class", "y axis")
          .call(yAxis)
        // .append("text")
        // .attr("transform", "rotate(-90)")
        // .attr("y", 6)
        // .attr("dy", ".71em")
        // .style("text-anchor", "end")
        // .text("Cases");

        var category = svg.selectAll(".category")
          .data(categories)
          .enter().append("g")
          .attr("class", "category");

        category.append("path")
          .attr("class", "line")
          .attr("d", function(d) { return line(d.values); })
          .style("stroke", function(d) { return color(d.name); });

        // category.append("text")
        //   .datum(function(d) { return {name: d.name, value: d.values[d.values.length - 1]}; })
        //   .attr("transform", function(d) { return "translate(" + x(d.value.date) + "," + y(d.value.temperature) + ")"; })
        //   .attr("x", 3)
        //   .attr("dy", ".35em")
        //   .text(function(d) { return d.name; });

        // svg.on("click", function(d){
        //   console.log('Clicked is'+  xScale.invert(d3.event.pageX));
        //   $scope.currentTimestamp = moment(d.date, "YYYY-MM-DD");
        // });

        svg.on("click", function() {
          var tmpWidth = d3.select("#lineChartMap").node().getBBox().width;

          var widthPerDate = tmpWidth / $scope.availableTimestamps.length;

          var dateIdx = Math.ceil(d3.mouse(this)[0]/widthPerDate);

          $scope.currentTimestampIdx = dateIdx;

          $scope.currentTimestamp =  moment($scope.availableTimestamps[dateIdx], "YYYY-MM-DD").format("ddd DD MMMM YYYY");

          dateChanged(dateIdx);
          if (!$scope.$$phase) $scope.$apply();

        });




        // var legend = svg.append("g")
        //   .attr("class", "legend")
        //   .attr("width", width)
        //   .attr("transform", "translate(-1000,50")
        //   .data(cities)
        //   .enter()
        //   .append('g')
        //   .attr('class', 'legend');
        //
        // legend.append('rect')
        //   .attr('x', width - 20)
        //   .attr('y', function(d, i){ return i *  20;})
        //   .attr('width', 10)
        //   .attr('height', 10)
        //   .style('fill', function(d) {
        //     return color(d.name);
        //   });
        //
        // legend.append('text')
        //   .attr('x', width - 8)
        //   .attr('y', function(d, i){ return (i *  20) + 9;})
        //   .text(function(d){ return d.name; });


        var mouseG = svg.append("g")
          .attr("class", "mouse-over-effects");

        mouseG.append("path") // this is the black vertical line to follow mouse
          .attr("class", "mouse-line")
          .style("stroke", "white")
          .style("stroke-width", "1px")
          .style("opacity", "0");

        mouseG.append("text")
          .attr("id", "chartDateText")
          .attr("x", 9)
          .attr("y", 25)
          .attr("fill", "white");


        mouseG.append('svg:rect') // append a rect to catch mouse movements on canvas
          .attr('width', width) // can't catch mouse events on a g element
          .attr('height', height)
          .attr('fill', 'none')
          .attr('pointer-events', 'all')
          .on('mouseout', function() { // on mouse out hide line, circles and text
            d3.select(".mouse-line")
              .style("opacity", "0");

            d3.select("#chartDateText").style("opacity", "0");
          })
          .on('mouseover', function() { // on mouse in show line, circles and text
            d3.select(".mouse-line")
              .style("opacity", "1");

            d3.select("#chartDateText").style("opacity", "1");

            d3.select("#chartDateText").text(function(d,i){


            })
          })
          .on('mousemove', function() { // mouse moving over canvas
            var mouse = d3.mouse(this);
            d3.select(".mouse-line")
              .attr("d", function() {
                var d = "M" + mouse[0] + "," + height;
                d += " " + mouse[0] + "," + 0;
                return d;
              });

            var tmpWidth = d3.select("#lineChartMap").node().getBBox().width;

            var widthPerDate = tmpWidth / $scope.availableTimestamps.length;

            var dateIdx = Math.ceil(d3.mouse(this)[0]/widthPerDate);

            // console.log("Selected date: ", $scope.availableTimestamps[dateIdx]);


            d3.select("#chartDateText")
              .text( moment($scope.availableTimestamps[dateIdx], "YYYY-MM-DD").format("DD-MMMM-YYYY"))
              .attr("x", d3.mouse(this)[0] + 2);


          });


        $scope.currentTimestamp = moment($scope.availableTimestamps[0], "YYYY-MM-DD").format("ddd DD MMMM YYYY");

        // $scope.currentTimestamp = $scope.availableTimestamps[0];

        // console.log("Available Timestamps: ", $scope.availableTimestamps);
        // console.log("Current ts: ",$scope.currentTimestamp);

        if (!$scope.$$phase) $scope.$apply();


      });
    };

    var createLineChartNumber = function(){
      d3.select(".expensesChart").remove();
      $(".expensesChart").remove();

      var svg = d3.select("#expenses-chart-map").append("svg"),
        margin = {top: 20, right: screen.width*0.04, bottom: 30, left: 50},
        width = screen.width*0.90,
        height = screen.height * 0.18 - margin.top - margin.bottom,
        g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      svg.attr("class", "expensesChart");

      var parseDate = d3.time.format("%Y-%m-%d").parse;

      var x = d3.time.scale()
        .range([0, width]);

      var y = d3.scale.linear()
        .range([height, 0]);


      var xAxis = d3.svg.axis()
        .scale(x)
        .orient("bottom");

      var yAxis = d3.svg.axis()
        .scale(y)
        .orient("left");

      var line = d3.svg.line()
        .interpolate("basis")
        .x(function(d) { return x(d.date); })
        .y(function(d) { return y(d.expense); });

      svg
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
        .attr("id","lineChartMap")
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      //

      d3.csv("/data/cajamar_data/imp_sec_ts.csv", function(error, data) {
        // d3.csv("/data/cajamar_data/sector_counts.csv", function(error, data) {
        if (error) throw error;
        $scope.availableTimestamps = [];

        color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

        data.forEach(function(d) {
          // console.log("d: ", d);
          $scope.availableTimestamps.push(d.date);
          d.date = parseDate(d.date);
        });

        var categories = color.domain().map(function(name) {
          return {
            name: name,
            values: data.map(function(d) {
              return {date: d.date, expense: +d[name]};
            })
          };
        });

        x.domain(d3.extent(data, function(d) { return d.date; }));

        y.domain([
          d3.min(categories, function(c) { return d3.min(c.values, function(v) { return v.expense; }); }),
          d3.max(categories, function(c) { return d3.max(c.values, function(v) { return v.expense; }); })
        ]);

        g.append("g")
          .attr("class", "x axis")
          .attr("transform", "translate(0," + height + ")")
          .call(xAxis);

        g.append("g")
          .attr("class", "y axis")
          .call(yAxis)
        // .append("text")
        // .attr("transform", "rotate(-90)")
        // .attr("y", 6)
        // .attr("dy", ".71em")
        // .style("text-anchor", "end")
        // .text("Cases");

        var category = svg.selectAll(".category")
          .data(categories)
          .enter().append("g")
          .attr("class", "category");

        category.append("path")
          .attr("class", "line")
          .attr("d", function(d) { return line(d.values); })
          .style("stroke", function(d) { return color(d.name); });

        // category.append("text")
        //   .datum(function(d) { return {name: d.name, value: d.values[d.values.length - 1]}; })
        //   .attr("transform", function(d) { return "translate(" + x(d.value.date) + "," + y(d.value.temperature) + ")"; })
        //   .attr("x", 3)
        //   .attr("dy", ".35em")
        //   .text(function(d) { return d.name; });

        // svg.on("click", function(d){
        //   console.log('Clicked is'+  xScale.invert(d3.event.pageX));
        //   $scope.currentTimestamp = moment(d.date, "YYYY-MM-DD");
        // });

        var parser = d3.dsv(";","text/plain");
        parser("/data/aemet/weather.csv", function(error, wData) {
          weatherData = wData;

          console.log("weatherData: ", weatherData);


          wData.forEach(function (d) {
            if (d.prec == "False") {
              d.value = 1;
            } else {
              d.value = 0;

              d.date = parseDate(d.fecha);
            }

          });
          console.log("Weather data: ", wData);
          data = wData;
        });


        svg.on("click", function() {
          var tmpWidth = d3.select("#lineChartMap").node().getBBox().width;

          var widthPerDate = tmpWidth / $scope.availableTimestamps.length;

          var dateIdx = Math.ceil(d3.mouse(this)[0]/widthPerDate);

          $scope.currentTimestampIdx = dateIdx;

          $scope.currentTimestamp =  moment($scope.availableTimestamps[dateIdx], "YYYY-MM-DD").format("ddd DD MMMM YYYY");

          dateChanged(dateIdx);
          if (!$scope.$$phase) $scope.$apply();

        });




        // var legend = svg.append("g")
        //   .attr("class", "legend")
        //   .attr("width", width)
        //   .attr("transform", "translate(-1000,50")
        //   .data(cities)
        //   .enter()
        //   .append('g')
        //   .attr('class', 'legend');
        //
        // legend.append('rect')
        //   .attr('x', width - 20)
        //   .attr('y', function(d, i){ return i *  20;})
        //   .attr('width', 10)
        //   .attr('height', 10)
        //   .style('fill', function(d) {
        //     return color(d.name);
        //   });
        //
        // legend.append('text')
        //   .attr('x', width - 8)
        //   .attr('y', function(d, i){ return (i *  20) + 9;})
        //   .text(function(d){ return d.name; });


        var mouseG = svg.append("g")
          .attr("class", "mouse-over-effects");

        mouseG.append("path") // this is the black vertical line to follow mouse
          .attr("class", "mouse-line")
          .style("stroke", "white")
          .style("stroke-width", "1px")
          .style("opacity", "0");

        mouseG.append("text")
          .attr("id", "chartDateText")
          .attr("x", 9)
          .attr("y", 25)
          .attr("fill", "white");


        mouseG.append('svg:rect') // append a rect to catch mouse movements on canvas
          .attr('width', width) // can't catch mouse events on a g element
          .attr('height', height)
          .attr('fill', 'none')
          .attr('pointer-events', 'all')
          .on('mouseout', function() { // on mouse out hide line, circles and text
            d3.select(".mouse-line")
              .style("opacity", "0");

            d3.select("#chartDateText").style("opacity", "0");
          })
          .on('mouseover', function() { // on mouse in show line, circles and text
            d3.select(".mouse-line")
              .style("opacity", "1");

            d3.select("#chartDateText").style("opacity", "1");

            d3.select("#chartDateText").text(function(d,i){


            })
          })
          .on('mousemove', function() { // mouse moving over canvas
            var mouse = d3.mouse(this);
            d3.select(".mouse-line")
              .attr("d", function() {
                var d = "M" + mouse[0] + "," + height;
                d += " " + mouse[0] + "," + 0;
                return d;
              });

            var tmpWidth = d3.select("#lineChartMap").node().getBBox().width;

            var widthPerDate = tmpWidth / $scope.availableTimestamps.length;

            var dateIdx = Math.ceil(d3.mouse(this)[0]/widthPerDate);

            // console.log("Selected date: ", $scope.availableTimestamps[dateIdx]);


            d3.select("#chartDateText")
              .text( moment($scope.availableTimestamps[dateIdx], "YYYY-MM-DD").format("DD-MMMM-YYYY"))
              .attr("x", d3.mouse(this)[0] + 2);


          });


        $scope.currentTimestamp = moment($scope.availableTimestamps[0], "YYYY-MM-DD").format("ddd DD MMMM YYYY");

        // $scope.currentTimestamp = $scope.availableTimestamps[0];

        // console.log("Available Timestamps: ", $scope.availableTimestamps);
        // console.log("Current ts: ",$scope.currentTimestamp);

        if (!$scope.$$phase) $scope.$apply();


      });
    };


    var createBarChart = function(){
      var margin = {top: 0, right: screen.width*0.01, bottom: 30, left: 5},
        width = screen.width*0.08,
        height = screen.height * 0.78 - margin.top - margin.bottom;

// Parse the date / time
      var	parseDate = d3.time.format("%Y-%m-%d").parse;



      var svg = d3.select("#weather-chart").append("svg")
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
        .append("g")
        .attr("transform",
          "translate(" + margin.left + "," + margin.top + ")");



      var data;

      var parser = d3.dsv(";","text/plain");
      parser("/data/aemet/weather.csv", function(error, wData) {
        weatherData = wData;

        console.log("weatherData: ", weatherData);


        wData.forEach(function(d){
          if(d.prec == "False"){
            d.value = 1;
          }else{
            d.value = 0;

            d.date = parseDate(d.fecha);
          }

        });
        console.log("Weather data: ", wData);
        data = wData;


        var x = d3.scale.linear()
          .range([0, width])
          .domain([0, d3.max(data, function (d) {
            return d.value;
          })]);

        var y = d3.scale.ordinal()
          .rangeRoundBands([height, 0], .1)
          .domain(data.map(function (d) {
            return d.name;
          }));

        //make y axis to show bar names
        var yAxis = d3.svg.axis()
          .scale(y)
          //no tick marks
          .tickSize(0)
          .orient("left");

        var gy = svg.append("g")
          .attr("class", "y axis")
          .call(yAxis);

        var bars = svg.selectAll(".bar")
          .data(data)
          .enter()
          .append("g")
          .style("fill", "blue");

        //append rects
        bars.append("rect")
          .attr("class", "bar")
          .attr("y", function (d) {
            return y(d.date);
          })
          .attr("height", y.rangeBand())
          .attr("x", 0)
          .attr("width", function (d) {
            return x(d.value);
          });



      });



    };



    createMap();
    createLineChartNumber();
    // createLineChartVolume();

    // createBarChart();
  });
