'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('OfferCtrl', function ($scope, $location) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];

    var categoryColors = ['#9e0142','#d53e4f','#f46d43','#fdae61','#fee08b','#e6f598','#abdda4','#66c2a5','#3288bd','#5e4fa2', '#888888']//["#ffffd9","#edf8b1","#c7e9b4","#7fcdbb","#41b6c4","#1d91c0","#225ea8","#253494","#081d58", "#ffffff"];
    var categoryNames = ["food","shops","parks_outdoors","nightlife","travel","arts_entertainment","building","education"];

    var categoryValues =[1768,446,300,204,184,165,57,6];



    $scope.options = {
      origin:1,
      granularity:0,
      info:1
    };


    var color = d3.scale.ordinal()
      .domain(categoryNames)
      .range(categoryColors);

    $scope.categoryColors = categoryColors;
    $scope.categoryNames = categoryNames;

    $("#lateral_container_offer").css("width", screen.width * 0.25 + "px");
    $("#lateral_container_offer").css("margin-left", screen.width * 0.03 + "px");
    $("#lateral_container_offer").css("height", screen.height * 0.60 + "px");
    // $("#lateral_container").css("background-color", "white");


    $scope.currentTimestamp;
    $scope.currentTimestampIdx=0;
    $scope.availableTimestamps = [];

    var cpPolygons;
    var cpPolygonsData;
    var choosenPolygon;

    var colorToAssign;
    var categoryToAssign;

    var tmp;
    var category;


    var weatherData;

    $scope.currentDateWeather = "Sun";


    var selectWeatherIcon = function(dateIdx){
      if(weatherData[dateIdx].prec == "False"){
        console.log("Sun");

        $scope.currentDateWeather = "Sun";
      }else{
        console.log("Rain");

        $scope.currentDateWeather = "Rain";
      }
    };

    var chooseCategoryForCP = function(cpId, dateIdx, tipus){

      // Use tipus 0 for showing data by VOLUME of transactions
      // Use tipus 1 for showing data by NUMBER of transactions


      if(tipus == 0){
        tmp = cpPolygonsData[dateIdx][cpId].substring(0,2);
      }else{
        tmp = cpPolygonsData[dateIdx][cpId].substring(2);
      }


      return chooseColorForCP(tmp);


    };

    var chooseColorForCP = function(numCategory){
      if(numCategory == ""){
        return "#060606";
      }else{

        if(numCategory < 2){
          numCategory = numCategory *10;
        }
        if(numCategory != 10) {
          numCategory = numCategory%10;
        }


        return categoryColors[numCategory];

        // return color(Math.floor((Math.random() * 10) + 1)%10);

      }
    };

    var changePolygonColors = function(dateIdx){
      console.log("Changing category colors for day: ", dateIdx);

      cpPolygons.each(function(d, i) {
        // console.log("Polygon: ", d, i);
        choosenPolygon = d3.select("#CP_"+d.properties.COD_POSTAL);

        colorToAssign = chooseCategoryForCP(d.properties.COD_POSTAL, dateIdx, $scope.options.origin);
        choosenPolygon
          .style("opacity", 0.8)
          .style("fill", colorToAssign);

      });
    };

    var dateChanged = function(dateIdx){

      changePolygonColors(dateIdx);

      if(weatherData !== undefined){

        selectWeatherIcon(dateIdx);
      }

    };

    $scope.infoOptionsChanged = function(){
      console.log("Information option changed to: " + $scope.options.info);

      if($scope.options.info == 0){  // Consumption
        $location.path( "/map" );
      }
      // else if($scope.options.info == 1){  // Commercial offer
      //   $location.path( "/offer" );
      // }
      else if($scope.options.info == 2){  // Demographics
        $location.path( "/demography" );
      }
      else if($scope.options.info == 3){  // Transportation
        $location.path( "/transportation" );
      }
      else if($scope.options.info == 4){  // Richness
        $location.path( "/richness" );
      }

    };




    var createChart = function() {


      var width = screen.width * 0.66;
      var height = screen.height * 0.67;

      var r = Math.min(width, height) / 3;

      $("#offerChart").css("width", width + "px");
      $("#offerChart").css("height", height + "px");
      $("#offerChart").css("margin-left", screen.width * 0.07 + "px");

      color = d3.scale.category20c();     //builtin range of colors

    /*  var vis = d3.select("body")
        .append("svg:svg")              //create the SVG element inside the <body>
                        //associate our data with the document
        .attr("width", w)           //set the width and height of our visualization (these will be attributes of the <svg> tag
        .attr("height", h)
        .append("svg:g")                //make a group to hold our pie chart
        .attr("transform", "translate(" + r + "," + r + ")")    //move the center of the pie chart from 0, 0 to radius, radius*/






      d3.csv("data/foursquare/foursquare_distribution.csv", function (error, data) {

        var vis = d3.select("#offerChart").append("svg")
          .data([data])   //this will create arc data for us given a list of values
          .attr("width", width)
          .attr("height", height)
          .append("g")
          .attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");


        var arc = d3.svg.arc()              //this will create <path> elements for us using arc data
          .outerRadius(r);


        var pie = d3.layout.pie()
          .value(function(d) { return d.score; });    //we must tell it out to access the value of each element in our data array


      var arcs = vis.selectAll("g.slice")     //this selects all <g> elements with class slice (there aren't any yet)
        .data(pie)                          //associate the generated pie data (an array of arcs, each having startAngle, endAngle and value properties)
        .enter()                            //this will create <g> elements for every "extra" data element that should be associated with a selection. The result is creating a <g> for every object in the data array
        .append("svg:g")                //create a group to hold each slice (we will have a <path> and a <text> element associated with each slice)
        .attr("class", "slice");    //allow us to style things in the slices (like text)

      arcs.append("svg:path")
        .attr("fill", function(d, i) { return color(i); } ) //set the color for each slice to be chosen from the color function defined above
        .attr("d", arc);                                    //this creates the actual SVG path using the associated data (pie) with the arc drawing function

      arcs.append("svg:text")                                     //add a label to each slice
        .attr("transform", function(d) {                    //set the label's origin to the center of the arc
          //we have to make sure to set these before calling arc.centroid
          d.innerRadius = 0;
          d.outerRadius = r;
          return "translate(" + arc.centroid(d) + ")";        //this gives us a pair of coordinates like [50, 50]
        })
        .attr("text-anchor", "middle")    ;                      //center the text on it's origin
        // .text(function(d, i) { return data[i].; })
        // .attr("fill", "white");


        var legendContainer = d3.select('#offerChart').append("svg")
          .attr("height", height*0.7)
          .attr("transform", "translate(" + width*0.8 + ", -200)");

        var legendRectSize = 20;
      var legendSpacing = 5;
        var legendG = legendContainer
        // var legend = svg
          .append("g")
          .style("z-index", 9999);
        var legend = legendG
          .selectAll("g")
          .data(color)
          .enter()
          .append('g')
          .attr('class', 'legend')
          .attr('transform', function(d, i) {
            var partialHeight = legendRectSize;
            var x = 0;
            var y = i * partialHeight;
            return 'translate(' + x + ',' + y + ')';
          });


        legend.append('rect')
          .attr('width', legendRectSize)
          .attr('height', legendRectSize)
          .style('fill', function(d, i){
            return color(i);
          })
          .style('stroke', function(d, i){
            return color(i);
          });

        // legendG.append("text").text("Legend (by richness)").attr("fill", "white");
        legend.append('text')
          .attr('x', legendRectSize + legendSpacing)
          .attr('y', legendRectSize - legendSpacing)
          .attr("fill", "white")
          .text(function(d, i) { return categoryNames[i] + "    - " + categoryValues[i] + " venues"; });


        introJs().start();
      });




      // d3.csv("data/foursquare/foursquare_distribution.csv", type, function (error, data) {


    }

    $scope.showTutorial = function(){
      introJs().start();
    };

    createChart();
    // createLineChart();

    // createBarChart();
  });
