'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('RichnessCtrl', function ($scope, $location) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];

    /*
     if(parseInt(selectedRowFromRichnessData[categoryString]) < 13000){
     return richnessCategoryColors[0];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 15000){
     return richnessCategoryColors[1];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 17000){
     return richnessCategoryColors[2];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 20000){
     return richnessCategoryColors[3];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 23000){
     return richnessCategoryColors[4];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 26000){
     return richnessCategoryColors[5];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 33000){
     return richnessCategoryColors[6];
     }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 38000){
     return richnessCategoryColors[7];
     } else{
     return richnessCategoryColors[8];
     }
     */

    var richnessCategoryColors = ['#f7fcf5','#e5f5e0','#c7e9c0','#a1d99b','#74c476','#41ab5d','#238b45','#006d2c','#00441b'];
    var richnessCategoryNames = ["< 12999 €", "13000-14999 €", "15000-16999 €", "17000-19999 €", "20000-22999 €", "23000-25999 €", "26000-32999 €", "33000-37999 €", "> 38000 €"];



    $scope.options = {
      origin:1,
      granularity:0,
      info:4
    };

    $("#lateral_container_richness").css("width", screen.width * 0.25 + "px");
    $("#lateral_container_richness").css("margin-left", screen.width * 0.03 + "px");
    $("#lateral_container_richness").css("height", screen.height * 0.60 + "px");

    $scope.currentTimestamp;
    $scope.currentTimestampIdx=0;
    $scope.availableTimestamps = [];

    var cpPolygons;
    var cpPolygonsRichnessData;
    var cpPolygonsRichnessDataStatistics = {};

    var choosenPolygon;

    var colorToAssign;

    var tmp;
    $scope.currentOptionSelected = 0;

    var selectedRowFromRichnessData;


    var getRichnessColorForpPolygon = function(CP){
      var categoryString = "RENTA_BRUTA_MEDIA";

      selectedRowFromRichnessData = cpPolygonsRichnessData.filter(function(d){
        return d.CP == CP;
      });
      if(selectedRowFromRichnessData.length > 0){
        selectedRowFromRichnessData = selectedRowFromRichnessData[0];

        if(parseInt(selectedRowFromRichnessData[categoryString]) < 13000){
          return richnessCategoryColors[0];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 15000){
          return richnessCategoryColors[1];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 17000){
          return richnessCategoryColors[2];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 20000){
          return richnessCategoryColors[3];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 23000){
          return richnessCategoryColors[4];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 26000){
          return richnessCategoryColors[5];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 33000){
          return richnessCategoryColors[6];
        }else if(parseInt(selectedRowFromRichnessData[categoryString]) < 38000){
          return richnessCategoryColors[7];
        } else{
          return richnessCategoryColors[8];
        }
      }else{
        return "black";
      }

    };

    var changePolygonColors = function(optionIdx){

      // 0-> Total richness
      // 1-> Men
      // 2-> Women
      console.log("Changing category colors for optionIdx: ", optionIdx);

      cpPolygons.each(function(d, i) {
        // console.log("Polygon: ", d, i);
        choosenPolygon = d3.select("#CP_"+d.properties.COD_POSTAL);

        colorToAssign = getRichnessColorForpPolygon(d.properties.COD_POSTAL, optionIdx);
        choosenPolygon
          .style("opacity", 0.8)
          .style("fill", colorToAssign);

      });
    };

    $scope.richnessOptionsChanged = function(){

      changePolygonColors($scope.currentOptionSelected);

    };

    $scope.infoOptionsChanged = function(){
      console.log("Information option changed to: " + $scope.options.info);

      if($scope.options.info == 0){  // Consumption
        $location.path( "/map" );
      }
      else if($scope.options.info == 1){  // Commercial offer
        $location.path( "/offer" );
      }
      else if($scope.options.info == 2){  // Demography
        $location.path( "/demography" );
      }
      else if($scope.options.info == 3){  // Transportation
        $location.path( "/transportation" );
      }
      // else if($scope.options.info == 4){  // Richness
      //   $location.path( "/richness" );
      // }

    };

    $scope.transactionsOptionsChanged = function() {
      console.log("Transactions option changed");
      dateChanged($scope.currentTimestampIdx);
    };




    var createMap = function() {


      var width = screen.width * 0.66;
      var height = screen.height * 0.78;


      $("#richnessMap").css("width", width + "px");
      $("#richnessMap").css("height", height + "px");
      $("#richnessMap").css("margin-left", screen.width * 0.07 + "px");


      //d3.select("#lineChart").node().getBBox().width;

      var legendHeight = screen.height * 0.35;

      // console.log("legendHeight: ", legendHeight);


      // var map = new L.Map("map", {center: [39.469214, -0.364603], zoom: 9});
      // var map = new L.Map("map", {center: [39.360966, -0.354603], zoom: 9});

      var map = new L.Map("richnessMap", {center: [39.288466, -0.434941], zoom: 9});

      //.addLayer(new L.TileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"));

      map.options.maxZoom = 14;
      map.options.minZoom = 8;

      var svg = d3.select(map.getPanes().overlayPane)
        .append("svg");

      svg.attr('width', width)
        .attr('height', height)
        .attr("class", "clickable");

      var g = svg.append("g")
        .attr("class", "leaflet-zoom-hide")
        .style("z-index", 9);

      var result;
      var tip = d3.tip()
        .attr('class', 'd3-tip')
        .offset([-10, 0])
        .html(function(d) {

          console.log("d: ", d);

          result = cpPolygonsRichnessData.filter(function(p){
            return p.CP == d.properties.COD_POSTAL;
          });

          result = result[0];

          return "<h4> Postal code: "+d.properties.COD_POSTAL+"</h4><br>"+
            "<strong>Median income:</strong> <span style='color:forestgreen'>" + parseInt(result.RENTA_BRUTA_MEDIA) + "</span><br>" ;

        });


      d3.json("data/postales/cp_valencia_province.geojson", function (error, geojson) {

        // console.log("Extracted data: ", geojson);
        var transform = d3.geo.transform({point: projectPoint}),
          path = d3.geo.path().projection(transform);

        var feature = g.selectAll("path")
          .data(geojson.features)
          .enter()
          .append("path")
          .attr("id", function (d) {
            return "CP_"+d.properties.COD_POSTAL;
          })
          .style("stroke", "grey")
          .style("stroke-width", "0.5")
          // .style("fill", function(d,i) { return color(i%10); } )
          // .style("opacity", 0.8);
          .style("opacity", 0);


        feature.call(tip);

        feature.on('mouseover', tip.show)
          .on('mouseout', tip.hide);

        cpPolygons = feature;

        map.on("viewreset", reset);
        reset();

        // Reposition the SVG to cover the features.
        function reset() {
          var bounds = path.bounds(geojson),
            topLeft = bounds[0],
            bottomRight = bounds[1];

          svg.attr("width", bottomRight[0] - topLeft[0])
            .attr("height", bottomRight[1] - topLeft[1])
            .style("left", topLeft[0] + "px")
            .style("top", (topLeft[1] -legendHeight * 1.8) + "px");

          g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");

          feature.attr("d", path);
        }


        // Use Leaflet to implement a D3 geometric transformation.
        function projectPoint(x, y) {
          var point = map.latLngToLayerPoint(new L.LatLng(y, x));
          this.stream.point(point.x, point.y);
        }



        var parser = d3.dsv(";","text/plain");
        parser("/data/hacienda/renta_media.csv", function(csvError, csvData) {
          console.log("csv Data :: ", csvData);
          // console.log("Date IDX: ",$scope.currentTimestampIdx);
          // console.log("Data from that date: ", csvData[$scope.currentTimestampIdx]);


          cpPolygonsRichnessData = csvData;

          var categoryString = "RENTA_BRUTA_MEDIA";

          var max = d3.max(cpPolygonsRichnessData, function(d) { return parseInt(d[categoryString])});
          var min = d3.min(cpPolygonsRichnessData, function(d) { return parseInt(d[categoryString])});

          cpPolygonsRichnessDataStatistics["RENTA_BRUTA_MEDIA"] = {max: max, min: min};


          console.log("Statistics: ", cpPolygonsRichnessDataStatistics);

          changePolygonColors($scope.currentOptionSelected);
          var legendRectSize = 20;
          var legendSpacing = 5;



          var legendContainer = d3.select('#richnessMapProperties')
            .attr("height", height*0.7)
            .attr("transform", "translate(" + width*0.8 + ",220)");


          var legendG = legendContainer
          // var legend = svg
            .append("g")
            .style("z-index", 9999);
          var legend = legendG
            .selectAll("g")
            .data(richnessCategoryColors)
            .enter()
            .append('g')
            .attr('class', 'legend')
            .attr('transform', function(d, i) {
              var partialHeight = legendRectSize;
              var x = 0;
              var y = i * partialHeight;
              return 'translate(' + x + ',' + y + ')';
            });


          legend.append('rect')
            .attr('width', legendRectSize)
            .attr('height', legendRectSize)
            .style('fill', function(d, i){
              return richnessCategoryColors[i];
            })
            .style('stroke', function(d, i){
              return richnessCategoryColors[i];
            });

          // legendG.append("text").text("Legend (by richness)").attr("fill", "white");
          legend.append('text')
            .attr('x', legendRectSize + legendSpacing)
            .attr('y', legendRectSize - legendSpacing)
            .attr("fill", "white")
            .text(function(d, i) { return richnessCategoryNames[i]; });



        });
        introJs().start();
      });
    };

    $scope.showTutorial = function(){
      introJs().start();
    }

    createMap();
  });
