'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('TransportationCtrl', function ($scope, $location) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];


    $scope.options = {
      origin:1,
      granularity:0,
      info:3
    };


    $("#lateral_container_transportation").css("width", screen.width * 0.25 + "px");
    $("#lateral_container_transportation").css("margin-left", screen.width * 0.03 + "px");
    $("#lateral_container_transportation").css("height", screen.height * 0.60 + "px");


    $scope.infoOptionsChanged = function(){
      console.log("Information option changed to: " + $scope.options.info);

      if($scope.options.info == 0){  // Consumption
        $location.path( "/map" );
      }
      else if($scope.options.info == 1){  // Commercial offer
        $location.path( "/offer" );
      }
      else if($scope.options.info == 2){  // Demography
        $location.path( "/demography" );
      }
      // else if($scope.options.info == 3){  // Transportation
      //   $location.path( "/transportation" );
      // }
      else if($scope.options.info == 4){  // Richness
        $location.path( "/richness" );
      }

    };


    var createChord = function(){

      var width = screen.width * 0.66;
      var height = screen.height * 0.67;

      var cpPolygons, g;


      $("#chord").css("width", width + "px");
      $("#chord").css("height", height + "px");
      $("#chord").css("margin-left", screen.width * 0.07 + "px");

      var w = width,
        h = height,
        r1 = Math.min(h*0.7, w*0.7) / 2,
        r0 = r1 - 80;

      var fill = d3.scale.category20c();

      var chord = d3.layout.chord()
        .padding(.04)
        .sortSubgroups(d3.descending)
        .sortChords(d3.descending);

      var arc = d3.svg.arc()
        .innerRadius(r0)
        .outerRadius(r0 + 20);

      var svg = d3.select("#chord").append("svg:svg")
        .attr("width", w)
        .attr("height", h)
        .append("svg:g")
        .attr("transform", "translate(" + w / 2 + "," + h / 2 + ")");

      var parser = d3.dsv(";","text/plain");
      parser("data/cajamar_data/transportation_normalized_by_region.csv", function(transport) {

        transport = transport.slice(0,25);
        var indexByName = {},
          nameByIndex = {},
          matrix = [],
          val = 0,
          n = 0;

        self.names = [];


        // Compute a unique index for each package name.
        transport.forEach(function(d) {
          d = d.CP_CLIENTE;
          if (!(d in indexByName)) {
            nameByIndex[n] = d;
            indexByName[d] = n++;
            names.push(d);
          }
        });

        // Construct a square matrix counting package transport.
        transport.forEach(function(d) {
          var source = indexByName[d.CP_CLIENTE],
            row = matrix[source];
          if (!row) {
            row = matrix[source] = [];
            for (var i = -1; ++i < n;) row[i] = 0;
          }

          for(var k in d){

            if(d[k] < 8){
              val = 0;
            }else{
              val = d[k] * 10;
            }
              row[indexByName[k]] = val;
          };
        });


        chord.matrix(matrix);

        console.log("Matrix: ", matrix);

        var g = svg.selectAll("g.group")
          .data(chord.groups)
          .enter().append("svg:g")
          .attr("class", "group")
          .on("mouseover", fade(.02))
          .on("mouseout", fade(.80));

        g.append("svg:path")
          .style("stroke", function(d) { return fill(d.index); })
          .style("fill", function(d) { return fill(d.index); })
          .attr("d", arc);

        g.append("svg:text")
          .each(function(d) { d.angle = (d.startAngle + d.endAngle) / 2; })
          .attr("dy", ".35em")
          .style("fill", "white")
          .attr("text-anchor", function(d) { return d.angle > Math.PI ? "end" : null; })
          .attr("transform", function(d) {
            return "rotate(" + (d.angle * 180 / Math.PI - 90) + ")"
              + "translate(" + (r0 + 26) + ")"
              + (d.angle > Math.PI ? "rotate(180)" : "");
          })
          .text(function(d) { return nameByIndex[d.index]; });

        svg.selectAll("path.chord")
          .data(chord.chords)
          .enter().append("svg:path")
          .attr("class", "chord")
          .style("stroke", function(d) { return d3.rgb(fill(d.source.index)).darker(); })
          .style("fill", function(d) { return fill(d.source.index); })
          .attr("d", d3.svg.chord().radius(r0));


        introJs().start();

      });

      // d3.json("data/postales/cp_valencia_province.geojson", function (error, geojson) {
      //
      //   // console.log("Extracted data: ", geojson);
      //   var transform = d3.geo.transform({point: projectPoint}),
      //     path = d3.geo.path().projection(transform);
      //
      //   var feature = g.selectAll("path")
      //     .data(geojson.features)
      //     .enter()
      //     .append("path")
      //     .attr("id", function (d) {
      //       return "CP_"+d.properties.COD_POSTAL;
      //     })
      //     .style("stroke", "grey")
      //     .style("stroke-width", "0.5")
      //     // .style("fill", function(d,i) { return color(i%10); } )
      //     // .style("opacity", 0.8);
      //     .style("opacity", 0);
      //
      //
      //
      //   feature.call(tip);
      //
      //   feature.on('mouseover', tip.show)
      //     .on('mouseout', tip.hide)
      //   cpPolygons = feature;
      //
      //   map.on("viewreset", reset);
      //   reset();
      //
      //   // Reposition the SVG to cover the features.
      //   function reset() {
      //     var bounds = path.bounds(geojson),
      //       topLeft = bounds[0],
      //       bottomRight = bounds[1];
      //
      //     svg.attr("width", bottomRight[0] - topLeft[0])
      //       .attr("height", bottomRight[1] - topLeft[1])
      //       .style("left", topLeft[0] + "px")
      //       .style("top", (topLeft[1] -legendHeight*1.4) + "px");
      //
      //     g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");
      //
      //     feature.attr("d", path);
      //   }
      //
      //
      //   // Use Leaflet to implement a D3 geometric transformation.
      //   function projectPoint(x, y) {
      //     var point = map.latLngToLayerPoint(new L.LatLng(y, x));
      //     this.stream.point(point.x, point.y);
      //   }
      //
      //
      //   var parser = d3.dsv(";","text/plain");
      //   parser("/data/cajamar_data/determine_sector_day_byclient.csv", function(csvError, csvData) {
      //     // console.log("csv Data :: ", csvData);
      //     // console.log("Date IDX: ",$scope.currentTimestampIdx);
      //     // console.log("Data from that date: ", csvData[$scope.currentTimestampIdx]);
      //
      //     cpPolygonsData = csvData;
      //
      //     changePolygonColors($scope.currentTimestampIdx);
      //
      //   });
      // });

// Returns an event handler for fading a given chord group.
      function fade(opacity) {
        return function(d, i) {
          svg.selectAll("path.chord")
            .filter(function(d) { console.log(d);return d.source.index != i && d.target.index != i; })
            .transition()
            .style("stroke-opacity", opacity)
            .style("fill-opacity", opacity);
        };
      }
    }


    $scope.showTutorial = function(){
      introJs().start();
    };

    createChord();

  });
