'use strict';

/**
 * @ngdoc function
 * @name visualMinersApp.controller:AboutCtrl
 * @description
 * # AboutCtrl
 * Controller of the visualMinersApp
 */
angular.module('visualMinersApp')
  .controller('ValenciaCtrl', function ($scope) {
    this.awesomeThings = [
      'HTML5 Boilerplate',
      'AngularJS',
      'Karma'
    ];

    var categoryColors = ['#9e0142','#d53e4f','#f46d43','#fdae61','#fee08b','#e6f598','#abdda4','#66c2a5','#3288bd','#5e4fa2']//["#ffffd9","#edf8b1","#c7e9b4","#7fcdbb","#41b6c4","#1d91c0","#225ea8","#253494","#081d58", "#ffffff"];
    var categoryNames = ["ALIMENTACION","AUTO","BELLEZA","HIPERMERCADOS","HOGAR","MODA Y COMPLEMENTOS","OCIO Y TIEMPO LIBRE","OTROS","RESTAURACION","SALUD","TECNOLOGIA"];


    var color = d3.scale.ordinal()
      .domain(categoryNames)
      .range(categoryColors);

    $scope.categoryColors = categoryColors;
    $scope.categoryNames = categoryNames;

    $("#lateralContainerValencia").css("width", screen.width * 0.22 + "px");
    $("#lateralContainerValencia").css("margin-left", screen.width * 0.03 + "px");
    $("#lateralContainerValencia").css("height", screen.height * 0.75 + "px");
    /*$("#lateralContainerValencia").css("background-color", "white");*/



    var createMap = function() {


      var width = screen.width * 0.36;
      var height = screen.height * 0.65;


      $("#mapValencia").css("width", width + "px");
      $("#mapValencia").css("height", height + "px");
      $("#mapValencia").css("margin-left", screen.width * 0.06 + "px");


      $("#mapValencia2").css("width", width + "px");
      $("#mapValencia2").css("height", height + "px");
      $("#mapValencia2").css("margin-left", screen.width * 0.06 + "px");

      $("#mapValencia").css("border-right-color", "white");
      $("#mapValencia2").css("border-left-color", "white");



      var map = new L.Map("mapValencia", {center: [39.469014, -0.364603], zoom: 12});
      var map2 = new L.Map("mapValencia2", {center: [39.469014, -0.364603], zoom: 12, zoomControl: false});
      //.addLayer(new L.TileLayer("http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"));

      map.options.maxZoom = 14;
      map.options.minZoom = 8;


      map2.options.maxZoom = 14;
      map2.options.minZoom = 8;

      map.on('zoomend', function(d, i) {
        console.log("d_ ", d);
        map2.setZoom(d.target._zoom);
      });




      var svg = d3.select(map.getPanes().overlayPane)
        .append("svg");

      svg.attr('width', width)
        .attr('height', height);

      var g = svg.append("g")
        .attr("class", "leaflet-zoom-hide")
        .style("z-index", 9999);

      var svg2 = d3.select(map2.getPanes().overlayPane)
        .append("svg");

      svg2.attr('width', width)
        .attr('height', height);

      var g2 = svg2.append("g")
        .attr("class", "leaflet-zoom-hide")
        .style("z-index", 9999);

      var marker;


      d3.json("data/catastro/parcelas_catastrales_simplified.geojson", function(error, geojson) {
      // d3.json("data/catastro/parcelas_catastrales.geojson", function (error, geojson) {
        //
        console.log("Extracted data: ", geojson);
        var transform = d3.geo.transform({point: projectPoint}),
          path = d3.geo.path().projection(transform);

        var transform2 = d3.geo.transform({point: projectPoint2}),
          path2 = d3.geo.path().projection(transform2);

        var feature = g.selectAll("path")
          // .data(geojson.features)
        .data(geojson.geometries)
          .enter()
          .append("path")
          .attr("CP", function (d) {
            // console.log("D -> ", d);
            return 1;
          })
          .style("stroke", "grey")
          .style("stroke-width", "0.5")
          .style("fill", "white")
          .style("opacity", 0.8);

        var feature2 = g2.selectAll("path")
        // .data(geojson.features)
          .data(geojson.geometries)
          .enter()
          .append("path")
          .attr("CP", function (d) {
            // console.log("D -> ", d);
            return 1;
          })
          .style("stroke", "grey")
          .style("stroke-width", "0.5")
          .style("fill", "white")
          .style("opacity", 0.8);

        map.on("viewreset", reset);
        map2.on("viewreset", reset2);
        reset();
        reset2();

        // Reposition the SVG to cover the features.
        function reset() {
          var bounds = path.bounds(geojson),
            topLeft = bounds[0],
            bottomRight = bounds[1];

          svg.attr("width", bottomRight[0] - topLeft[0])
            .attr("height", bottomRight[1] - topLeft[1])
            .style("left", topLeft[0] + "px")
            .style("top", topLeft[1] + "px");

          g.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");


          g.selectAll("circle").attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");

          feature.attr("d", path);
        }

        function reset2() {
          var bounds = path.bounds(geojson),
            topLeft = bounds[0],
            bottomRight = bounds[1];

          svg2.attr("width", bottomRight[0] - topLeft[0])
            .attr("height", bottomRight[1] - topLeft[1])
            .style("left", topLeft[0] + "px")
            .style("top", topLeft[1] + "px");

          g2.attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");


          g2.selectAll("circle").attr("transform", "translate(" + -topLeft[0] + "," + -topLeft[1] + ")");

          feature2.attr("d", path);
        }


        // Use Leaflet to implement a D3 geometric transformation.
        function projectPoint(x, y) {
          var point = map.latLngToLayerPoint(new L.LatLng(y, x));
          this.stream.point(point.x, point.y);
        }


        function projectPoint2(x, y) {
          var point = map2.latLngToLayerPoint(new L.LatLng(y, x));
          this.stream.point(point.x, point.y);
        }


        d3.json("data/foursquare/venues.json", function(error, fsData) {
          console.log("fsData: ", fsData);
          var venues = []
          // var categories = [];

          // var bbox = [[39.436672, -0.438074],[39.501535, -0.329166]]
          // fsData.slice(0,1800).forEach(function(venue) {
          //   if (venue.hasOwnProperty("location") && venue.location.hasOwnProperty("lat") && venue.location.hasOwnProperty("lng")) {
          //     if(venue.location.lat > bbox[0][0] && venue.location.lat < bbox[1][0]){
          //       if(venue.location.lng > bbox[0][1] && venue.location.lng < bbox[1][1]){
          //         marker = new L.marker([venue.location.lat, venue.location.lng])
          //           .bindPopup(venue.name)
          //           .addTo(map);
          //
          //         marker.addTo(map2);
          //
          //         marker.setZIndexOffset(1000);
          //
          //         marker.on('mouseover', function (e) {
          //           console.log("Mouse over");
          //           this.openPopup();
          //         });
          //       }
          //
          //     }
          //
          //   }
          // });



          // svg2.selectAll("circle")
          //   .data(fsData)
          //   .enter()
          //   .append("circle")
          //   .attr("cx", function(d) {
          //     return projectPoint2([d.location.lng, d.location.lat])[0];
          //   })
          //   .attr("cy", function(d) {
          //     return projectPoint2([d.location.lng, d.location.lat])[1];
          //   })
          //   .attr("r", 5)
          //   .style("fill", "yellow")
          //   .style("opacity", 0.75);

           fsData.forEach(function(venue){
          //   // console.log("Venue: ",venue)
            if(venue.hasOwnProperty("location") && venue.location.hasOwnProperty("lat") && venue.location.hasOwnProperty("lng")){
          //
          //     marker = new L.marker([venue.location.lat, venue.location.lng])
          //       .bindPopup(venue.name)
          //       .addTo(map);
              venues.push( {
                point: map.latLngToLayerPoint(new L.LatLng(venue.location.lat, venue.location.lng)),
                point2: map2.latLngToLayerPoint(new L.LatLng(venue.location.lat, venue.location.lng)),
                category : venue.categories[0].name,
                name: venue.name
              });

              // if(categories.indexOf(venue.categories[0].name) < 0){
              //   categories.push(venue.categories[0].name)
              // }
            }
          })

          // svg.selectAll("circle")
          //   .data(venues)
          //   .enter()
          //   .append("circle")
          //       .attr("cx", function(d){ return d.point.x } )
          //       .attr("cy", function(d){ return d.point.y } )
          //   .attr("r", 5)
          //   .style("fill", "yellow")
          //   .style("opacity", 0.75);

          // svg2.selectAll("circle")
          //   .data(venues)
          //   .enter()
          //   .append("circle")
          //   .attr("cx", function(d){ return d.point2.x } )
          //   .attr("cy", function(d){ return d.point2.y } )
          //   .attr("r", 5)
          //   .style("fill", "yellow")
          //   .style("opacity", 0.75);
          //
          // console.log("venues: ", venues);
          // console.log("categories: ", categories);


          g.selectAll("circle").data( venues ).enter().append("circle")
            .attr("cx", function(d){ return d.point.x } )
            .attr("cy", function(d){ return d.point.y } )
            .attr("r", 10 )
            .style("fill", "teal")

        });

      });
    };



    var createLineChart = function(){
      var svg = d3.select("#chartValencia").append("svg"),
        margin = {top: 20, right: 80, bottom: 30, left: 50},
        width = screen.width*0.96,
        height = screen.height * 0.12 - margin.top - margin.bottom,
        g = svg.append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      var parseDate = d3.time.format("%Y-%m-%d").parse;

      var x = d3.time.scale()
        .range([0, width]);

      var y = d3.scale.linear()
        .range([height, 0]);


      var xAxis = d3.svg.axis()
        .scale(x)
        .orient("bottom");

      var yAxis = d3.svg.axis()
        .scale(y)
        .orient("left");

      var line = d3.svg.line()
        .interpolate("basis")
        .x(function(d) { return x(d.date); })
        .y(function(d) { return y(d.temperature); });

      svg
        .attr("width", width + margin.left + margin.right)
        .attr("height", height + margin.top + margin.bottom)
        .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

      //

      d3.csv("/data/cajamar_data/imp_sec_ts.csv", function(error, data) {
        if (error) throw error;

        color.domain(d3.keys(data[0]).filter(function(key) { return key !== "date"; }));

        data.forEach(function(d) {
          // console.log("d: ", d);
          d.date = parseDate(d.date);
        });

        var cities = color.domain().map(function(name) {
          return {
            name: name,
            values: data.map(function(d) {
              return {date: d.date, temperature: +d[name]};
            })
          };
        });

        console.log("Color: ", cities);

        x.domain(d3.extent(data, function(d) { return d.date; }));

        y.domain([
          d3.min(cities, function(c) { return d3.min(c.values, function(v) { return v.temperature; }); }),
          d3.max(cities, function(c) { return d3.max(c.values, function(v) { return v.temperature; }); })
        ]);

        g.append("g")
          .attr("class", "x axis")
          .attr("transform", "translate(0," + height + ")")
          .call(xAxis);

        g.append("g")
          .attr("class", "y axis")
          .call(yAxis)
          .append("text")
          .attr("transform", "rotate(-90)")
          .attr("y", 6)
          .attr("dy", ".71em")
          .style("text-anchor", "end")
          .text("Cases");

        var city = svg.selectAll(".city")
          .data(cities)
          .enter().append("g")
          .attr("class", "city");

        city.append("path")
          .attr("class", "line")
          .attr("d", function(d) { return line(d.values); })
          .style("stroke", function(d) { return color(d.name); });

        city.append("text")
          .datum(function(d) { return {name: d.name, value: d.values[d.values.length - 1]}; })
          .attr("transform", function(d) { return "translate(" + x(d.value.date) + "," + y(d.value.temperature) + ")"; })
          .attr("x", 3)
          .attr("dy", ".35em")
          .text(function(d) { return d.name; });


        // var legend = svg.append("g")
        //   .attr("class", "legend")
        //   .attr("width", width)
        //   .attr("transform", "translate(-1000,50")
        //   .data(cities)
        //   .enter()
        //   .append('g')
        //   .attr('class', 'legend');
        //
        // legend.append('rect')
        //   .attr('x', width - 20)
        //   .attr('y', function(d, i){ return i *  20;})
        //   .attr('width', 10)
        //   .attr('height', 10)
        //   .style('fill', function(d) {
        //     return color(d.name);
        //   });
        //
        // legend.append('text')
        //   .attr('x', width - 8)
        //   .attr('y', function(d, i){ return (i *  20) + 9;})
        //   .text(function(d){ return d.name; });

      });
    };



    $scope.showTutorial = function(){
      introJs().start();
    }
    createMap();
    // createLineChart();

  });
